/*
 * Copyright (C) 2005 by CERN
 */

/*
 * @(#)$RCSfile: lcg_util.h,v $ $Revision: 1.25 $ $Date: 2008/01/21 12:43:02 $ CERN Jean-Philippe Baud
 */

#ifndef _LCG_UTIL_H
#define _LCG_UTIL_H

#include "gfal_api.h"

typedef struct {
        GFAL_LONG64 transferred_bytes;
        float instant_throughput;
        float avg_throughput;
} perf_t;
                                                                                                                             
typedef void (* copyfile_callback_t) (
        perf_t                  s_perf,
        struct  timespec        ts,
        int                     *timeoutflg
        /* set timeoutflg = 1 to cancel the copy operation*/
        );




/* The maximum length of an LFN */
#define LCG_MAXPATHLEN 1023

		/* User-callable entry points */

const char *lcg_util_version ();
int lcg_aa (char *, char *, char *, char *, int);
int lcg_aax (char *, char *, char *, char *, int, char *, int);
int lcg_cp (char *, char *, char *, int, char *, int, int);
int lcg_cpt (char *, char *, char *, int, char *, int, int, int);
int lcg_cpx (char *, char *, char *, int, char *, int, int, char *, int);
int lcg_cpxt (char *, char *, char *, int, char *, int, int, int, char *, int);
int lcg_cp2 (char *, char *, char *, int, char *, int, int, int, char *, char *, char *, int);
int lcg_cp3 (char *, char *, enum se_type, enum se_type, enum se_type, int, char *, int, char *, int, int, int, char *, char *, char *, int);
int lcg_cr (char *, char *, char *, char *, char *, char *, int, char *, int, int, char *);
int lcg_crt (char *, char *, char *, char *, char *, char *, int, char *, int, int, int, char *);
int lcg_crx (char *, char *, char *, char *, char *, char *, int, char *, int, int, char *, char *, int);
int lcg_crxt (char *, char *, char *, char *, char *, char *, int, char *, int, int, int, char *, char *, int);
int lcg_cr2 (char *, char *, char *, char *, char *, char *, int, char *, int, int, int, char *, char *, char *, int);
int lcg_cr3 (char *, char *, char *, char *, enum se_type, enum se_type, int, char *, char *, int, char *, int, int, int, char *, char *, char *, int);
int lcg_del (char *, int, char *, char *, char *, int, int);
int lcg_delt (char *, int, char *, char *, char *, int, int, int);
int lcg_delx (char *, int, char *, char *, char *, int, int, char *, int);
int lcg_delxt (char *, int, char *, char *, char *, int, int, int, char *, int);
int lcg_del3 (char *, enum se_type, enum se_type, int, int, char *, char *, char *, int, int, int, char *, int);
int lcg_gt (char *, char *, char **, int *, int *, char **);
int lcg_gtt (char *, char *, char **, int *, int *, char **, int);
int lcg_gtx (char *, char *, char **, int *, int *, char **, char *, int);
int lcg_gtxt (char *, char *, char **, int *, int *, char **, char *, int, int);
int lcg_gt2 (char *, char **, char **, int *, int *, char **, char *, int, int, char *);
int lcg_gt3 (char *, enum se_type, enum se_type, int, char **, char **, int *, int *, char **, char *, int, int, char *);
int lcg_la (char *, char *, char *, int, char ***);
int lcg_lax (char *, char *, char *, int, char ***, char *, int);
int lcg_lg (char *, char *, char *, int, char *);
int lcg_lgx (char *, char *, char *, int, char *, char *, int);
int lcg_lr (char *, char *, char *, int, char ***);
int lcg_lrx (char *, char *, char *, int, char ***, char *, int);
int lcg_ra (char *, char *, char *, char *, int);
int lcg_rax (char *, char *, char *, char *, int, char *, int);
int lcg_rep (char *, char *, char *, char *, int, char *, int, int);
int lcg_rept (char *, char *, char *, char *, int, char *, int, int, int);
int lcg_repx (char *, char *, char *, char *, int, char *, int, int, char *, int);
int lcg_repxt (char *, char *, char *, char *, int, char *, int, int, int, char *, int);
int lcg_rep2 (char *, char *, char *, char *, int, char *, int, int, int, char *, char *, char *, int);
int lcg_rep3 (char *, char *, enum se_type, enum se_type, enum se_type, int, char *, char *, int, char *, int, int, int, char *, char *, char **, char *, int);
int lcg_rf (char *, char *, char *, char *, char *, int, int, char *);
int lcg_rft (char *, char *, char *, char *, char *, int, int, int, char *);
int lcg_rfx (char *, char *, char *, char *, char *, int, int, char *, char *, int);
int lcg_rfxt (char *, char *, char *, char *, char *, int, int, int, char *, char *, int);
int lcg_sd (char *, int, int, char *, int);
int lcg_sdt (char *, int, int, char *, int, int);
int lcg_sdx (char *, int, int, char *, int, char *, int);
int lcg_sdxt (char *, int, int, char *, int, char *, int, int);
int lcg_uf (char *, char *, char *, char *, int);
int lcg_ufx (char *, char *, char *, char *, int, char *, int);
void copy_print_callback(perf_t, struct timespec, int *);

		/* Internal functions */

int copyfile (char *, char *, int, char *, int);
int copyfilex (char *, char *, int, char *, int, int, copyfile_callback_t);
int deletesfn (char *, char *, int);
int deletesfnt (char *, char *, int, int);
int getfilesize (char *, GFAL_LONG64 *, char *, int);
int getfilesizet (char *, GFAL_LONG64 *, char *, int, int);
int makedir (char *, char *, int);
int makedirt (char *, char *, int, int);
int makedirp (char *, char *, int);
int makedirpt (char *, char *, int, int);
int se_match (char *, char *, char *, int);
#endif
